// Thoms Dorn
// Ethernet Visualisierung
// WS 1996/97
// E881 8625093

import java.applet.*;
import java.awt.*;

public class Ether extends Applet
{
  static final String message = "Thomas Dorn (tdorn@vip.at)";
  Font font;

//+ "Initialisierung der Buttons, Labels und Panels"

  // Needed Buttons
  Button b_stepB;
  Button f_stepB;

  Button b_playB;
  Button f_playB;

  Choice speedB;

  Choice packetB[][] = new Choice [10][6];
  Choice destB[][]   = new Choice [10][6];
  Checkbox connectB[]  = new Checkbox [6];


  // Needed Labels

  Label overL;
  Label timeL;
  Label sliceL;
  Label stepL;
  Label playL;
  Label speedL;

  Label statusL[] = new Label[6];

  // Panels

  Panel mainP;
  Panel motionP;
  Panel dataP;
  Panel animP;
  Panel barsP;
  Panel timeP;
  Panel stepP;
  Panel playP;
  Panel speedP;
  Panel spcP[] = new Panel[6];
  Panel hpcP[] = new Panel[6];
  Panel pcP[] = new Panel[6];
  Panel progP[] = new Panel[6];

  Panel hstepP;
  Panel hplayP;

  Canvas progC[] = new Canvas[6];

  Panel num_panel;
  Panel func_panel;
  Button number[] = new Button[10];
  Button function[] = new Button[6];

//-

  // First Initialization (init Data)
  public void init()
  {

    setLayout(new BorderLayout());            // Initialize the global Layout
    overL = new Label("Ethernetvisualisierung", Label.CENTER);
    add("North",overL);

    // font = new Font("Helvetica", Font.BOLD, 12);
    // setFont(font);

    mainP = new Panel();
    mainP.setLayout(new FlowLayout());     // Main-Panel


    // Make the Label of Motion Panel
    timeL  = new Label("Time Slice", Label.CENTER);
    sliceL = new Label("00", Label.CENTER);
    stepL  = new Label("Step", Label.CENTER);
    playL  = new Label("Play", Label.CENTER);
    speedL = new Label("Speed", Label.CENTER);


    // Make the Buttons of Motion Panel
    b_stepB = new Button(" < ");
    f_stepB = new Button(" > ");

    b_playB = new Button(" < ");
    f_playB = new Button(" > ");

    speedB  = new Choice();
    speedB.addItem("slow");
    speedB.addItem("medium");
    speedB.addItem("high");

    // ###############  motion Panel  ######################################

    motionP = new Panel();
    motionP.setLayout(new GridLayout(1,4));     // Motion-Panel

    timeP = new Panel();
    timeP.setLayout(new BorderLayout());     // Time-Panel

    hstepP = new Panel();
    hstepP.setLayout(new BorderLayout());     // Step-Panel  Help

    hplayP = new Panel();
    hplayP.setLayout(new BorderLayout());     // Play-Panel  Help

    stepP = new Panel();
    stepP.setLayout(new BorderLayout());     // Step-Panel

    playP = new Panel();
    playP.setLayout(new BorderLayout());     // Play-Panel

    speedP = new Panel();
    speedP.setLayout(new BorderLayout());     // Speed-Panel


    timeP.add ("North", timeL);
    timeP.add ("South", sliceL);


    hstepP.add ("East", f_stepB);
    hstepP.add ("West", b_stepB);
    stepP.add ("North", stepL);
    stepP.add ("South", hstepP);

    hplayP.add ("East", f_playB);
    hplayP.add ("West", b_playB);
    playP.add ("North", playL);
    playP.add ("South", hplayP);

    speedP.add ("North", speedL);
    speedP.add ("South", speedB);

    motionP.add(timeP);
    motionP.add(stepP);
    motionP.add(playP);
    motionP.add(speedP);


    // ############### Data Panel #########################################
    dataP = new Panel();
    dataP.setLayout(new GridLayout(1,6));     // Data-Panel


    for (int i=0;i<6;i++)
    {
      pcP[i] = new Panel();
      pcP[i].setLayout(new BorderLayout());     // PC-Panel (Packet/dest, Connect)

      hpcP[i] = new Panel();
      hpcP[i].setLayout(new GridLayout(10,2));     // PC-Panel packt+dest

      spcP[i] = new Panel();
      spcP[i].setLayout(new BorderLayout(3,1));     // PC-Panel Connect, Status, Bars
    }

    // ############### Data Buttons #########################################
    for (int i=0;i<6;i++)
    {
      connectB[i] = new Checkbox("Connect");
      statusL[i] = new Label("Status", Label.CENTER);
      for (int j=0;j<10;j++)
      {
	packetB[j][i] = new Choice();
	packetB[j][i].addItem("No");
	packetB[j][i].addItem("Small");
	packetB[j][i].addItem("Large");
	destB[j][i] = new Choice();
	destB[j][i].addItem("D1");
	destB[j][i].addItem("D2");
	destB[j][i].addItem("D3");
	destB[j][i].addItem("D4");
	destB[j][i].addItem("D5");
	destB[j][i].addItem("D6");
	destB[j][i].addItem("D7");
	destB[j][i].addItem("D8");
      }
    }
    // ############### Data Bindings #########################################
    for (int i=0;i<6;i++)
    {
      for (int j=0;j<10;j++)
      {
	hpcP[i].add(packetB[j][i]);
	hpcP[i].add(destB[j][i]);
      }

      progC[i] = new MyCanvas(10,i*10,30);

      spcP[i].add("North", connectB[i]);
      spcP[i].add("Center",statusL[i]);
      spcP[i].add("South", progC[i]);

      pcP[i].add("North",hpcP[i]);
      pcP[i].add("South",spcP[i]);

      dataP.add(pcP[i]);
    }



    // ############### binding with Main-Panel ################################
    mainP.add(motionP);
    mainP.add(dataP);
    add("Center", mainP);

  }

  // Grundzeichnung
  public void paint(Graphics g)
  {
    // Obere Zeile (Steuerzeile)
    g.setColor(Color.white);
    g.drawRoundRect(0,0,620,50,10,10);
    g.setColor(Color.black);
    g.drawRoundRect(1,1,620,50,10,10);
    g.setFont(font);
    g.drawString("Time",20,20);
    g.drawString("Step",120,20);
    g.drawString("Play",220,20);
    g.drawString("Speed",320,20);
    g.drawString("Ethernet Visualizing",420,20);

  }
  public static void main(String args[]) 
  {
	System.out.println("Ethernetvisualisierung");
	Frame f = new Frame("Ethernetvisualisierung");
	Applet applet = new Ether();
	applet.init();
	applet.start();
	f.add("Center", applet);
	f.resize(800,600);
	f.show();
  }
}


class MyCanvas extends Canvas
{
    int tra;
    int rec;
    int col;

    public MyCanvas(int tra, int rec, int col)
    {
      this.tra = tra;
      this.rec = rec;
      this.col = col;
    }

    public void paint(Graphics g)
    {
	int w = size().width;
	int h = size().height;
	g.draw3DRect(0, 0, w - 1, h - 1, true);
	g.drawString("Auslastung", (w - g.getFontMetrics().stringWidth("Auslastung"))/2,
		      10);

	g.setFont(new Font("Helvetica", Font.PLAIN, 8));

	g.setColor(Color.yellow);
	g.fillRect(10,15,tra+10,10);
	g.setColor(Color.green);
	g.fillRect(10,25,rec+10,10);
	g.setColor(Color.red);
	g.fillRect(10,35,col+10,10);
	g.setColor(Color.black);

	g.drawString("T", 1, 24);
	g.drawString("R", 1, 34);
	g.drawString("C", 1, 44);
    }

    //If we don't specify this, the canvas might not show up at all
    //(depending on the layout manager).
    public Dimension minimumSize()
    {
	return new Dimension(100,50);
    }

    //If we don't specify this, the canvas might not show up at all
    //(depending on the layout manager).
    public Dimension preferredSize()
    {
	return minimumSize();
    }
}

